

#ifndef  __KEYBOARD_H__
#define  __KEYBOARD_H__


#include <stdint.h>


extern "C++" {
	namespace avelino {
		using namespace std;

		class KeyboardListener {
			public:
				virtual void buttonPressed(int8_t key) = 0;
		};

		class Keyboard {
			protected:
				static KeyboardListener *listener;
				static int8_t currentKey;
				static int32_t tickCounter;
				enum class Status : int8_t { IDLE, WAIT_AFTER_PRESSED };
				static Status status;
			public:
				static void init(KeyboardListener *listener);
				static void interrupt()  __attribute__ ((section(".exti")));
				static void tick();
		};
	}
}


#endif  // __KEYBOARD_H__
