

#include <stdint.h>
#include "Led.H"


using namespace std;
using namespace avelino;


#define  RCC_APB2ENR  *((volatile uint32_t *) 0x40021018)
#define  GPIOC_CRH    *((volatile uint32_t *) 0x40011004)
#define  GPIOC_ODR    *((volatile uint32_t *) 0x4001100C)


void Led::init() {
	// enable clock on port C
	RCC_APB2ENR |= ((uint32_t) 1) << 4;
	// PC13 as push-pull output (max 2 MHz)
	GPIOC_CRH = (GPIOC_CRH & 0xFF0FFFFF) | 0x00200000;
}


void Led::set(bool v) {
	if (v)
		GPIOC_ODR &= ~(((uint32_t) 1) << 13);
	else
		GPIOC_ODR |= (((uint32_t) 1) << 13);
}


void Led::toggle() {
	GPIOC_ODR ^= (((uint32_t) 1) << 13);
}

