

#ifndef  __STATICQUEUE_H__
#define  __STATICQUEUE_H__


extern "C++" {
	namespace avelino {
		using namespace std;

		template <typename T, int32_t N>
		class StaticQueue {
			public:
				T data[N];
				int32_t headIndex;
				int32_t tailIndex;
				void push(const T &v);
				const T &head() { return this->data[this->headIndex]; };
				void pop();
				bool empty() { return (this->headIndex == this->tailIndex); };
				StaticQueue() : headIndex(0), tailIndex(0) { };
		};

		template <typename T, int32_t N>
		void StaticQueue<T, N>::push(const T &v) {
			this->data[this->tailIndex] = v;
			this->tailIndex++;
			if (this->tailIndex == N)
				this->tailIndex = 0;
		}

		template <typename T, int32_t N>
		void StaticQueue<T, N>::pop() {
			this->headIndex++;
			if (this->headIndex == N)
				this->headIndex = 0;
		}
	}
}


#endif  // __STATICQUEUE_H__
